#include<stdio.h>
#include"neuralnet.h"

#define CLUSTERNUM 3
#define VECTORNUM 3
#define DIMENSION 3

int main()
{
	int i, j, k;
	int index;
	Cluster *cluster[CLUSTERNUM];
	Vector *v;

	v = CreateVector(DIMENSION);

	for(i=0; i<CLUSTERNUM; i++){
		cluster[i] = CreateCluster(VECTORNUM, DIMENSION);
	}
/*
	for(i=0; i<CLUSTERNUM; i++){
		for(j=0; j<VECTORNUM; j++){
			for(k=0; k<DIMENSION; k++){
				printf("cluster[%d]:vector[%d]:v[%d]: ", i, j, k);
				scanf("%lf", &(cluster[i]->v[j]->v[k]));
			}
		}
	}
*/
	
	cluster[0]->v[0]->v[0] = 1;
	cluster[0]->v[0]->v[1] = -1;
	cluster[0]->v[0]->v[2] = 1;
	cluster[0]->v[1]->v[0] = 1.5;
	cluster[0]->v[1]->v[1] = -0.8;
	cluster[0]->v[1]->v[2] = 1.3;
	cluster[0]->v[2]->v[0] = 2;
	cluster[0]->v[2]->v[1] = -1.6;
	cluster[0]->v[2]->v[2] = 3;
	cluster[1]->v[0]->v[0] = 1;
	cluster[1]->v[0]->v[1] = 1;
	cluster[1]->v[0]->v[2] = -1;
	cluster[1]->v[1]->v[0] = 1.3;
	cluster[1]->v[1]->v[1] = 1.6;
	cluster[1]->v[1]->v[2] = -2;
	cluster[1]->v[2]->v[0] = 1.1;
	cluster[1]->v[2]->v[1] = 2;
	cluster[1]->v[2]->v[2] = -1;
	cluster[2]->v[0]->v[0] = -1;
	cluster[2]->v[0]->v[1] = -1;
	cluster[2]->v[0]->v[2] = 1;
	cluster[2]->v[1]->v[0] = -1.2;
	cluster[2]->v[1]->v[1] = -0.8;
	cluster[2]->v[1]->v[2] = 2;
	cluster[2]->v[2]->v[0] = -2;
	cluster[2]->v[2]->v[1] = -1.4;
	cluster[2]->v[2]->v[2] = 0.8;

	v->v[0] = 1.5;
	v->v[1] = -2.3;
	v->v[2] = 2;

/*
	for(i=0; i<DIMENSION; i++){
		printf("v[%d]", i);
		scanf("%lf", &(v->v[i]));
	}
	*/

	for(i=0; i<CLUSTERNUM; i++){
		printf("Cluster[%d]:\n", i);
		for(j=0; j<VECTORNUM; j++){
			printf("Vector[%d]:", j);
			for(k=0; k<DIMENSION; k++){
				printf("%f ", cluster[i]->v[j]->v[k]);
			}
			printf("\n");
		}
		printf("\n");
	}
	
	printf("Unknown Vector:");
	for(i=0; i<DIMENSION; i++){
		printf("%f ", v->v[i]);
	}
	printf("\n\n");
	
	index = kNNrule(cluster, CLUSTERNUM, v, 2, 5);

	printf("v included of %d\n", index);

	for(i=0; i<CLUSTERNUM; i++){
		FreeCluster(cluster[i]);
	}

	FreeVector(v);

	return 0;
}


